      SUBROUTINE QSS2R(RINT,A,B,F,N,EPS,K,IND,R,IERR)
         INTEGER IERR,IND,K,N
         REAL A,B,EPS,R,RINT
         DIMENSION IND(N),R(N,3),RINT(N)
         EXTERNAL UTQS10
         INTEGER I,J,J1,K1,K2
         REAL E,H,H1,S
       IERR = 0
       DO 10 I = 1, N
          R(I,3) = 0.
          IND(I) = 0
   10  CONTINUE
       K1 = K
       IF (K .LE. 0) K1 = 1
       H = (B - A)/K1*.5
       CALL F(A,RINT,IND)
       CALL F(B,R,IND)
       DO 20 I = 1, N
          R(I,2) = (RINT(I) + R(I,1))*H
          RINT(I) = R(I,2)/3.
   20  CONTINUE
       K1 = K1 + K1 - 1
       J1 = -1
       DO 40 J = 1, K1
          CALL F(A + J*H,R,IND)
          J1 = -1*J1
          DO 30 I = 1, N
             RINT(I) = RINT(I) + (3. + J1)*R(I,1)*H/3.
             R(I,2) = R(I,2) + R(I,1)*2.*H
   30     CONTINUE
   40  CONTINUE
       IF (EPS .LE. 0.) GO TO 90
          K1 = K1 + 1
   50  CONTINUE
       H1 = H*.5
       DO 70 J = 1, K1
          CALL F(A + (2.*J - 1.)*H1,R,IND)
          DO 60 I = 1, N
             R(I,3) = R(I,3) + R(I,1)
   60     CONTINUE
   70  CONTINUE
       K2 = 1
       DO 80 I = 1, N
          IF (IND(I) .GT. 0) GO TO 80
             S = (R(I,2) + 4.*H*R(I,3))/6.
             E = ABS(RINT(I) - S)/(1. + ABS(S))
             RINT(I) = S
             IF (E .LE. EPS) IND(I) = K1/2
             R(I,2) = .5*R(I,2) + R(I,3)*H
             R(I,3) = 0.
             IF (IND(I) .EQ. 0) K2 = 0
   80  CONTINUE
       IF (K2 .GT. 0) GO TO 90
          K1 = K1 + K1
          H = H*.5
          IF (K1 .LE. 1048576) GO TO 50
             IERR = 65
             CALL UTQS10(IERR,9)
   90     RETURN
      END
